#!/bin/bash
file="/tmp/snap-info"
dir="/root/miner_data/heltec-snap"
download_dir="/var/www/html/download_snap"
if [ ! -d "$dir" ]
then
	mkdir $dir
fi

exist_snap=$(ls $download_dir | grep heltec-snap- )
if [ "$exist_snap" != "" ]
then
	exist_snap_time=$(stat -c %Y $download_dir/$exist_snap)
	timenow=$(date +%s)
	timepast=`expr $timenow - $exist_snap_time`
	if [ $timepast -lt 3600 ]
	then
		echo $exist_snap
		exit
	fi
fi

rm $download_dir/*
rm $dir/*

docker exec miner miner snapshot take /var/data/heltec-snap/snap
res=$(ls $dir)
n=0
while [ "$res" = "" ]
do
        sleep 10
	n=`expr $n + 1`
        res=$(ls $dir)
#	echo $n
	if [ "$n" = 30 ]
	then
		echo creat snapshot failed
		exit
	fi
done

res=$(docker exec miner miner snapshot info /var/data/heltec-snap/snap | grep Height)
n=0
while [ "$res" = "" ]
do
#	echo $res
	sleep 10
	n=`expr $n + 1`
	res=$(docker exec miner miner snapshot info /var/data/heltec-snap/snap | grep Height)
#	echo $n
	if [ "$n" = 30 ]
        then
                echo creat snapshot failed
                exit
        fi
done
docker exec miner miner snapshot info /var/data/heltec-snap/snap > $file

height=$(cat $file | grep Height | awk '{print $2}')
hashline=$(cat $file | grep Hash -n | grep Hash | awk -F: '{print $1}')
hashline1=`expr $hashline + 1`
tmp1=$(cat $file | head -$hashline | tail -1 | awk '{print $2}')
tmp2=$(cat $file | head -$hashline1 | tail -1 | awk '{print $1}')
hash=$(echo $tmp1$tmp2)
hash1=$(cat $file | head -$hashline1 | tail -1 | awk '{print $2}' | awk -F\" '{print $2}')

mv $dir/snap $dir/snap-$height
sha256=$(sha256sum $dir/snap-$height | awk '{print $1}')

file1="$dir/snapshotinfo"
echo "{" > $file1
echo "\"snapshot_hash\":\"$hash\"," >> $file1
echo "\"block\":$height," >> $file1
echo "\"hash_hex\":\"$hash1\"," >> $file1
echo "\"sha256\":\"$sha256\"" >> $file1
echo "}" >> $file1
#cat $file1


hash=$(echo $hash | awk -F'<<' '{print $2}' | awk -F'>>' '{print $1}')
error=0;

hashlength=${#hash1}
if [ "$hashlength" != "64" ]
then
	echo creat snapshot failed
	exit 0
fi

for((i=1;i<=32;i++))
do
	tmp=$(echo $hash | awk -v i="$i" -F, '{print $i}')
	n=`expr 2 \* $i - 2`
	tmp1=${hash1:`expr 2 \* $i - 2`:2}
	tmp1=$((16#$tmp1))
	if [ "$tmp" != "$tmp1" ]
	then
		error=`expr $error + 1`
	fi
done  

if [ "$error" != "0" ]
then
        echo creat snapshot failed
        exit
fi
tar -zcPf $download_dir/heltec-snap-$height.tar.gz $dir
sync
echo heltec-snap-$height.tar.gz
